
public class Buffer {

	private Semaphore freePlaces;
     private Semaphore occupiedPlaces;

	private int N; // Puffergroesse
	private Object[] buf;
	private int in = 0; // naechste freie Position
	private int out = 0; // Index d. abzugebenden Elements

	public Buffer(int size) {
		N = size;
	     buf = new Object[N]; // Array der Lnge N
          freePlaces= new Semaphore(N);
		occupiedPlaces= new Semaphore(0);
	}
	
	public void put(Object obj) throws InterruptedException {
		System.out.println("put " + obj + " called.");
		freePlaces.down();
		synchronized (this) {
			buf[in] = obj;
			in = (in + 1) % N;
			printStatus("put " + obj);
		}
		occupiedPlaces.up();
		System.out.println("put " + obj + " finished.");
	}

	public Object get() throws InterruptedException {
		System.out.println("get called.");
		occupiedPlaces.down();
		Object obj = null;
		synchronized (this) {
			obj = buf[out];
			buf[out] = "_";
			out = (out + 1) % N;
			printStatus("get  ");
		}
		freePlaces.up();
		System.out.println("get " + obj + " finished.");
		return obj;
	}
	
	private void printStatus(String s) {
		String output = "  " + s + " changed buffer to [";
		for (int i = 0; i < N; i++) {
			output += ((buf[i] == null) ? "_" : buf[i]);
			output += ((i < N - 1) ? "," : "]");
		}
		System.out.println(output);
	}
}
